FUNCTION Brel1
******
*       spec1(["p1 p2 p3", p4, p5])
*
*       "p1 p2 p3"      - polja koja se ne editiraju
*       p4              - .T. dozvoljava append
*       p5              - .T. dozvoljava brisanje
******
PARAMETERS not_edit, can_app, can_del
PRIVATE N,move_chrs,force_rec,ntx_expr,ntx_eval,prev_rec,;
         is_append,any_append,keystroke,e_field,get_data
r = 79
l = 0

SAVE SCREEN 

@ 0, 0 CLEAR TO 24, 79

* vrijednosti kontrplnih tipki za kretanje po ekranu
move_chrs = CHR(24) + CHR(5) + CHR(3) + CHR(18) + CHR(31) + CHR(30)

IF EOF()
         GO TOP 
ENDIF 

* inicijalizacija
force_rec   = .T.
is_append   = .F.
any_append  = .F.
prev_rec    = 0

IF LASTREC() = 0 .AND. can_app
         * prazan fajl,  idi u append mode
         KEYBOARD CHR(24)
ENDIF 

DBEDIT(0, 0, 24, 79, polja, 'xbrspec', .T., naziv_kol, "", " ", "", "")

*KEYBOARD CHR(255)

RESTORE SCREEN 
RETURN .T.

******
*       Xbrspec()
*
*       obradjuje specijalne tipke i vrsi ispis na ekran za vrijeme editiranja
******
FUNCTION Xbrspec

PARAMETERS Mode, f_script
PRIVATE Ret_val

* pretpostavi normalni mod
ret_val = 1

* zapamti zadnju pritisnutu tipku
keystroke = LASTKEY()

* uzmi polje u normalnu varijablu
e_field = polja[M->f_script]

IF M->prev_rec <> RECNO()
         * pomjeren je rekord pointer
         prev_rec = RECNO()
         force_rec = .T.
ENDIF 

DO CASE 
CASE M->mode = 1
         * bof bang
         IF M->is_append
                  * izlaz iz append moda..osvjezi ako ima novih rekorda
                  ret_val = IF (M->any_append, 2, 3)
                  is_append = .F.
                  any_append = .F.
         ENDIF 
         
         force_rec = .T.
         
CASE M->mode = 2
         * eof bang
         
         IF M->is_append
                  * append mod je aktivan
                  
                  IF M->keystroke = 24 .AND. .NOT. EOF()
                           * strelica dolje radi ponovo
                           ret_val = 3
                  ELSE 
                           IF M->keystroke = 6
                                    * End..izidji iz append moda..osvjezi ekran ako ima novih rekorda.
                                    ret_val = IF (M->any_append, 2, 3)
                                    is_append = .F.
                                    any_append = .F.
                           ENDIF 
                  ENDIF 
                  
         ELSE 
                  IF M->keystroke = 24
                           IF Can_app
                                    *udji u append mode
                                    ret_val   = 3
                                    is_append = .T.
                           ENDIF Can_app
                  ENDIF 
         ENDIF 
         
         force_rec = .T.
CASE M->mode = 3
         * fajl je prazan
         IF M->keystroke = 24
                  IF Can_app
                           * udji u append mod
                           ret_val   = 3
                           is_append = .T.
                           force_rec = .T.
                  ENDIF Can_app
         ENDIF 
CASE M->mode = 4
         * keystroke exception
         
         DO CASE 
         CASE M->keystroke = 1 .AND. .NOT. M->is_append
                  * Home..return down arrow if not append mode
                  KEYBOARD CHR(31)
         CASE M->keystroke = 27
                  ret_val = 0
                  
         CASE M->keystroke = 304 .AND. .NOT. EOF() .AND. LASTREC() <> 0
                  * delete tipka..postavi deleted() flag
                  IF Can_del
                           IF DELETED()
                                    SELECT &radna           &&
                                    TONE(7000,1)
                                    RECALL 
                                    SELECT user          && user
                                    RECALL 
                           ELSE 
                                    SELECT &radna           &&
                                    TONE(1100,1)
                                    DELETE 
                                    SELECT user          && user
                                    DELETE 
                           ENDIF DELETED()
                  ENDIF Can_del
                  
                  * ispisi  novi delete status
                  
         CASE (M->keystroke = 13 .OR. keys(M->keystroke)) .AND.;
                  (M->is_append .OR. (.NOT. EOF() .AND. LASTREC() <> 0))
                  * editiraj vazece polje
                  ntx_expr = INDEXKEY(0)                && get the controlling index key
                  
                  IF .NOT. EMPTY(M->ntx_expr)
                           * expand key for comparison after edit
                           ntx_eval = &ntx_expr
                  ENDIF 
                  SET CURSOR ON 
                  * upotrijebi memorijsku varijablu za unos podatka
                  get_data = &e_field
                  
                  * up and down strlica abortiraju upis
                  SET KEY 5 TO Clear_gets
                  SET KEY 24 TO Clear_gets
                  
                  * kolona za odredivanje replacea
                  get_data  = wspec_data()
                  keystroke = LASTKEY()         && zapamti zadnju pritisnutu tipku
                  
                  * ocisti tipke
                  SET KEY 5 TO 
                  SET KEY 24 TO 
                  
                  IF M->keystroke <> 27 .AND. UPDATED()
                           * potvrdjen novi podatak
                           
                           IF M->is_append .AND. EOF().AND.can_app
                                    * prvo polje u novom rekordu
                                    APPEND BLANK 
                                    any_append = .T.
                                    * osvjezi status liniju
                                    
                                    SELECT &radna  &&
                                    * dodan je novi slog, dodaj slog u maticnu
                                    * i postavi podatke za relaciju i br fakture
                                    APPEND BLANK 
                                    REPLACE user->user WITH RECNO()
                                    REPLACE &mat_filt WITH UPPER(&v_filt)
                                    SELECT user  && user
                           ENDIF 
                           * stavi ga gdje mu je mjesto
                           REPLACE &e_field WITH M->get_data
                           
                           
                           * pohvataj prave relacije zbog promjene sifre
                           record = RECNO()
                           GOTO TOP 
                           GOTO record
                           
                           * zamjeni vrijednosti polja od zavisnosti sifre...
*                          IF colona = 0 .OR. colona = 6       && sifra,kolicina
*                                   DO fak_relacija
*                          ELSEIF colona = 68                  && rabat
*                                   DO fak_rabat
*                          ENDIF COL() = 0
                  ENDIF 
                  
                  SET CURSOR OFF 
                  IF .NOT. EMPTY(M->ntx_expr) .AND. .NOT. M->is_append
                           * file indexed..check for altered key field
                           
                           IF M->ntx_eval <> (&ntx_expr)
                                    * key field altered..re-draw screen
                                    ret_val = 2
                                    
                           ENDIF 
                  ENDIF 
                  
                  IF M->ret_val <> 2
                           * certain keys move cursor after edit if no refresh
                           
                           DO CASE 
                                    
                           CASE M->keystroke = 5
                                    * up arrow
                                    
                                    IF M->is_append
                                             * no more append mode..refresh if new records
                                             ret_val = IF (M->any_append, 2, 3)
                                             is_append = .F.
                                             any_append = .F.
                                             
                                    ELSE 
                                             * pomjeri se jedan red na vise
                                             KEYBOARD CHR(5)
                                             
                                    ENDIF 
                                    
                           CASE M->keystroke = 18
                                    * PgUp
                                    
                                    IF M->is_append
                                             * no more append mode..refresh if new records
                                             ret_val = IF (M->any_append, 2, 3)
                                             is_append = .F.
                                             any_append = .F.
                                             
                                    ELSE 
                                             * pomjeri se jedan red na vise
                                             KEYBOARD CHR(5)
                                             
                                    ENDIF 
                                    
                           CASE M->keystroke = 24
                                    * down arrow
                                    KEYBOARD CHR(24)
                                    
                           CASE M->keystroke = 3 .AND. .NOT. M->is_append
                                    * PgDn..return down arrow if not append mode
                                    KEYBOARD CHR(24)
                                    
                           CASE M->keystroke = 1 .AND. .NOT. M->is_append
                                    * Home..return down arrow if not append mode
                                    KEYBOARD CHR(31)
                                    
                           CASE M->keystroke = 13
                                    * return..pomakni se desno
                                    KEYBOARD CHR(4)
                                    
                           ENDCASE 
                  ENDIF 
         ENDCASE 
ENDCASE 

RETURN M->ret_val
*****************************************
FUNCTION Keys
PARAMETERS K
RETURN (M->k >= 32 .AND. M->k < 249 .AND. M->k <> 219 .AND. CHR(M->k) <> ";")
*****************************************
FUNCTION Wspec_data
colona    = COL()
get_data1 = get_data
IF .NOT.ALLTRIM(STR(f_script))$"&not_edit"
         IF LASTKEY() # 13
                  KEYBOARD CHR(LASTKEY())
         ENDIF LASTKEY() # 13
         @ ROW(),COL() GET Get_data1 PICTURE Get_pic(M->e_field)
         BEGIN SEQUENCE
         Unos_enter()
         END SEQUENCE
ENDIF .NOT.ALLTRIM(STR(f_script))$"&not_edit"
RETURN Get_data1                && vrati unos u polje
